# -*- coding: utf-8 -*-

# Define your item pipelines here
#
# Don't forget to add your pipeline to the ITEM_PIPELINES setting
# See: https://docs.scrapy.org/en/latest/topics/item-pipeline.html

import json, os
from scrapy.exporters import CsvItemExporter

class ZbpblogPipeline(object):
    def process_item(self, item, spider):
        fn = "./data_file/" + os.path.basename(item['url']).strip(".html") + ".json"
        with open(fn, 'w', encoding="utf-8") as f:
            json.dump(dict(item), f)        # 要将item对象转为字典才能被json序列化

class Save2CsvPipeline(object):
    def open_spider(self, spider):  # open_spider和close_spider方法在爬虫的运行生命周期中只执行一次
        self.f = open("zbpblog.csv", "wb")      # 必须要用b的模式，写入字节流
        self.csv_helper = CsvItemExporter(self.f)
        self.csv_helper.start_exporting()   # 启动数据导出

    # PS: 如果在process_item方法return一个item，那么这个item会被传递给下一个pipeline
    # 如果不返回任何东西，那么就不会运行之后的pipeline，即pipeline的流程就到此结束
    def process_item(self, item, spider):
        self.csv_helper.export_item(item)       # 将item写入到csv

    def close_spider(self, spider):     # 关闭蜘蛛的时候要记得释放资源
        self.f.close()
        self.csv_helper.finish_exporting()